/*
 File: eval_phrases.h
 Date and Time: Fri Jan 30 18:55:11 2015 
*/
#ifndef __eval_phrases_h__
#define __eval_phrases_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"
// monolithic grammar: no thread
extern yacco2::State S1_Ceval_phrases;
namespace NS_eval_phrases {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[9];
};
class Ceval_phrases: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Reval_phrases_ = 569//start_of_rule_list + 0
    ,rhs1_Reval_phrases_ = 1
    ,rhs2_Reval_phrases_ = 2
   ,R_Rfsm_phrase_ = 570//start_of_rule_list + 2
    ,rhs1_Rfsm_phrase_ = 3
    ,rhs2_Rfsm_phrase_ = 4
   ,R_Rparallel_phrase_ = 571//start_of_rule_list + 4
    ,rhs1_Rparallel_phrase_ = 5
    ,rhs2_Rparallel_phrase_ = 6
   ,R_RT_enum_phrase_ = 572//start_of_rule_list + 6
    ,rhs1_RT_enum_phrase_ = 7
    ,rhs2_RT_enum_phrase_ = 8
   ,R_Rerr_sym_phrase_ = 573//start_of_rule_list + 8
    ,rhs1_Rerr_sym_phrase_ = 9
    ,rhs2_Rerr_sym_phrase_ = 10
   ,R_Rrc_phrase_ = 574//start_of_rule_list + 10
    ,rhs1_Rrc_phrase_ = 11
    ,rhs2_Rrc_phrase_ = 12
   ,R_Rlr1_k_phrase_ = 575//start_of_rule_list + 12
    ,rhs1_Rlr1_k_phrase_ = 13
    ,rhs2_Rlr1_k_phrase_ = 14
   ,R_Rterms_phrase_ = 576//start_of_rule_list + 14
    ,rhs1_Rterms_phrase_ = 15
    ,rhs2_Rterms_phrase_ = 16
   ,R_Rrules_phrase_ = 577//start_of_rule_list + 16
    ,rhs1_Rrules_phrase_ = 17
    ,rhs2_Rrules_phrase_ = 18
  };
  //no of la sets = 9
  //no of states = 26
  Ceval_phrases();
  ~Ceval_phrases();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[19];
  
	public:
	CAbs_lr1_sym* gps_;
	void post_error(CAbs_lr1_sym* Err);
	void post_gps(CAbs_lr1_sym* Sym);
	
 };
struct Reval_phrases;
struct Rfsm_phrase;
struct Rparallel_phrase;
struct RT_enum_phrase;
struct Rerr_sym_phrase;
struct Rrc_phrase;
struct Rlr1_k_phrase;
struct Rterms_phrase;
struct Rrules_phrase;
struct Reval_phrases:public yacco2::CAbs_lr1_sym {
  Reval_phrases(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rfsm_phrase:public yacco2::CAbs_lr1_sym {
  Rfsm_phrase(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rparallel_phrase:public yacco2::CAbs_lr1_sym {
  Rparallel_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct RT_enum_phrase:public yacco2::CAbs_lr1_sym {
  RT_enum_phrase(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rerr_sym_phrase:public yacco2::CAbs_lr1_sym {
  Rerr_sym_phrase(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rrc_phrase:public yacco2::CAbs_lr1_sym {
  Rrc_phrase(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rlr1_k_phrase:public yacco2::CAbs_lr1_sym {
  Rlr1_k_phrase(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rterms_phrase:public yacco2::CAbs_lr1_sym {
  Rterms_phrase(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rrules_phrase:public yacco2::CAbs_lr1_sym {
  Rrules_phrase(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

} // end of namespace

#endif
